﻿using System;
using System.Windows;
using System.Windows.Controls;

namespace SilverlightFuncionarios
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void ProcuraFunciButton_Click(object sender, RoutedEventArgs e)
        {
            int funcionarioID;

            if (int.TryParse(FunciIDTextBox.Text, out funcionarioID))
            {
                FuncionarioService.FuncionarioServiceClient proxy = new SilverlightFuncionarios.FuncionarioService.FuncionarioServiceClient();
                proxy.GetFuncionarioPorIdCompleted += new EventHandler<SilverlightFuncionarios.FuncionarioService.GetFuncionarioPorIdCompletedEventArgs>(proxy_GetFuncionarioPorIdCompleted);
                proxy.GetFuncionarioPorIdAsync(funcionarioID);
            }
            else
                ErrorTextBlock.Text = "O valor informado é inválido.(Informe somente valores numéricos)";
        }

        void proxy_GetFuncionarioPorIdCompleted(object sender, SilverlightFuncionarios.FuncionarioService.GetFuncionarioPorIdCompletedEventArgs e)
        {
            DetailGrid.DataContext = e.Result;
        }

        private void FunciDataGrid_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            DetailGrid.DataContext = FunciDataGrid.SelectedItem as FuncionarioService.Funcionario;
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {

            carregaTodosFuncionarios();
        }
        private void carregaTodosFuncionarios()
        {
            FuncionarioService.FuncionarioServiceClient proxy = new SilverlightFuncionarios.FuncionarioService.FuncionarioServiceClient();
            proxy.GetTodosFuncionariosCompleted += proxy_GetTodosFuncionariosCompleted;
            proxy.GetTodosFuncionariosAsync();
        }
        void proxy_GetTodosFuncionariosCompleted(object sender, SilverlightFuncionarios.FuncionarioService.GetTodosFuncionariosCompletedEventArgs e)
        {
            if (e.Error == null)
                FunciDataGrid.ItemsSource = e.Result;
            else
                ErrorTextBlock.Text = "Ocorreu um erro durante a comunicação com o serviço";
        }
    }
}
